using System;
using System.Collections.Generic;
using System.Text;

namespace DecoratorPattern
{
    class MessageProcessor:Decorator
    {
        private string serviceProvider;

        public MessageProcessor(BaseMessage message)
            : base(message)
        {
        }

        public string ServiceProvider
        {
            get
            {
                return this.serviceProvider;
            }
            set 
            {
                this.serviceProvider = value;
            }
        }

        public void PreProcess()
        {
            Console.WriteLine("Preprocessing message.");

        }

        public void PostProcess()
        {
            Console.WriteLine("Post processing message.");
        }

        public override void Send()
        {
            PreProcess();
            base.Send();
            PostProcess();
        }
    }
}
