using System;
using System.Collections.Generic;
using System.Text;

namespace DecoratorPattern
{
    class Program
    {
        static void Main(string[] args)
        {
            // Create SMS
            SMS sms = new SMS("123", "456", "test message");
            sms.Send();

            // Create MMS
            MMS mms = new MMS("123", "456", new byte[] { 1, 2 });
            mms.Send();
           
            // Set service provider, add pre and post post processing
            MessageProcessor messageProcessor = new MessageProcessor(sms);
            messageProcessor.ServiceProvider = "telco1";
            messageProcessor.Send();

            // Wait for user
            Console.Read();
        }
    }
}
